from struct import *
import time

# No checks! Does a straight copy of the whole tree!
def copy_dict(src, dest):
    for key in src.keys():
        if isinstance(src[key], dict):
            dest[key] = {}
            copy_dict(src[key], dest[key])
        elif isinstance(src[key], list):
            dest[key] = list(src[key])
        else:
            dest[key] =  src[key]

def l_endian_hexify(dec):
    b = hex(dec) #turn into hex
    b = b[2:] #take the 0x off
    b = ("0" * (4 - len(b)) + b) #Append needed "0"s
    l_e = b[2:]
    b_e = b[0:2]
    return l_e, b_e

def convert_12bit_bin_dump(dump):
    dump_len = len(dump)
    dump_len_arg = ">" + str(dump_len / 2) + "h"
    return unpack(dump_len_arg, dump)

def convert_8bit_dump(dump):
    return map(ord, dump)
    
def convert_logic_dump2(dump):
    int_ls = convert_8bit_dump(dump)
    bin_ls = []
    for s in int_ls:
        bin_ls.append(str(bin(s)[2:]).zfill(8))
    return bin_ls
    
def convert_logic_dump(dump):
    bin_ls = []
    for s in dump:
        bin_ls.append(num_to_bin(ord(s)))
    return bin_ls
    
def float_range(start, stop, step):
    mult = 10000
    start = int(start * mult)
    stop = int(stop * mult)
    step = int(step * mult)
    return [x / mult for x in range(start, stop, step)]

def num_to_bin(num):
    # Start at 128
    div = 128
    bin = []
    while div != 0:
        bit = 0
        if num >= div:
            # No need for an if statement, just multiply div by bit and then subtract.
            bit = 1
            num -= div
        bin.append(bit)
        div /= 2
        
    return bin
